var Cc=Components.classes;
var Ci=Components.interfaces;
function $(){
var _1=[];
for(var i=0;i<arguments.length;i++){
var _3=arguments[i];
if(typeof _3=="string"){
_3=document.getElementById(_3);
}
if(arguments.length==1){
return _3;
}
_1.push(_3);
}
return _1;
}
function getService(_4,_5){
return Cc[_4].getService(Ci[_5]);
}
var ERROR=0;
var WARN=1;
var INFO=2;
var DEBUG=3;
function Logger(){
}
Logger.prototype={debuglevel:ERROR,log:function(_6){
var _7=getService("@mozilla.org/consoleservice;1","nsIConsoleService");
_7.logStringMessage(_6);
dump(_6+"\n");
},debug:function(_8){
if(this.debuglevel>=DEBUG){
this.log("[DEBUG] "+_8);
}
},info:function(_9){
if(this.debuglevel>=INFO){
this.log("[INFO]  "+_9);
}
},warn:function(_a){
if(this.debuglevel>=WARN){
this.log("[WARN]  "+_a);
}
},error:function(_b){
if(this.debuglevel>=ERROR){
this.log("[ERROR] "+_b);
}
}};
var logger=new Logger();
try{
var cls=getService("@mozilla.org/appshell/commandLineService;1","nsICmdLineService");
logger.debuglevel=cls.getCmdLineValue("-debuglevel");
}
catch(e){
}
logger.debuglevel=DEBUG;
function Item(){
}
Item.prototype={_type:"urn:foxcart:cart#item",_curi:"urn:foxcart:items",about:"",title:"",_title:"http://purl.org/dc/elements/1.1/title",image:"",_image:"urn:foxcart:item#image",price:0,_price:"urn:foxcart:item#price",ship:0,_ship:"urn:foxcart:item#ship",seller:0,_seller:"urn:foxcart:item#seller",feeback:0,_feedback:"urn:foxcart:item#feedback",description:"",_description:"http://purl.org/dc/elements/1.1/description",date:"",_date:"http://purl.org/dc/elements/1.1/date",tags:[],_tags:"urn:foxcart:item#tag",};
function Tag(){
}
Tag.prototype={_type:"urn:foxcart:cart#tag",_curi:"urn:foxcart:tags",about:"",name:"",_name:"http://purl.org/dc/elements/1.1/title",date:"",_date:"http://purl.org/dc/elements/1.1/date",items:[],_items:"urn:foxcart:tag#item",};
function ExtractorProfile(){
}
ExtractorProfile.prototype={_type:"urn:foxcart:cart#extractor",_curi:"urn:foxcart:extractors",about:"",name:"",_name:"http://purl.org/dc/elements/1.1/title",host:"",_host:"urn:foxcart:extractor#host",title:"",_title:"urn:foxcart:extractor#title",image:"",_image:"urn:foxcart:extractor#image",price:"",_price:"urn:foxcart:extractor#price",ship:"",_ship:"urn:foxcart:extractor#ship",seller:"",_seller:"urn:foxcart:extractor#seller",feedback:"",_feedback:"urn:foxcart:extractor#feedback",description:"",_description:"urn:foxcart:extractor#description",};
var dataVersion="0.0.1";
var dataURI="urn:foxcart:data";
var dataVersionURI="urn:foxcart:data#version";
var rdfService=getService("@mozilla.org/rdf/rdf-service;1","nsIRDFService");
var rdfContainerUtils=getService("@mozilla.org/rdf/container-utils;1","nsIRDFContainerUtils");
function CartSession(){
this.init();
}
CartSession.prototype={_config_file:"cart.rdf",datasource:null,_rdfType:rdfService.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type"),init:function(_c){
var _d,_e,_f,_10,url;
if(_c){
this._config_file=_c;
}
with(window){
_d=getService("@mozilla.org/file/directory_service;1","nsIProperties");
_e=getService("@mozilla.org/network/protocol;1?name=file","nsIFileProtocolHandler");
}
_10=_d.get("ProfD",Components.interfaces.nsIFile);
_10.append(this._config_file);
try{
var _12=!_10.exists();
if(_12){
_10.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE,436);
var ds=Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource);
var _14=Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
_14.init(_10,2|8|32,436,0);
var _15=Components.classes["@mozilla.org/rdf/xml-serializer;1"].createInstance(Components.interfaces.nsIRDFXMLSerializer);
_15.init(ds);
_15.QueryInterface(Components.interfaces.nsIRDFXMLSource);
_15.Serialize(_14);
}
url=_e.newFileURI(_10);
this.datasource=rdfService.GetDataSourceBlocking(url.spec);
this.dbinit(_12);
}
catch(e){
logger.error(e);
}
},dbinit:function(_16){
if(_16){
this.assert(rdfService.GetResource(dataURI),rdfService.GetResource(dataVersionURI),rdfService.GetLiteral(dataVersion));
this.flush();
}
},assert:function(sub,_18,obj,_1a){
logger.debug("Assert "+sub.Value+" "+_18.Value+" "+obj.Value);
if(!_1a){
var en=this.datasource.GetTargets(sub,_18,true);
while(en.hasMoreElements()){
this.unassert(sub,_18,en.getNext().QueryInterface(Ci.nsIRDFNode));
}
}
this.datasource.Assert(sub,_18,obj,true);
},unassert:function(sub,_1d,obj){
logger.debug("Unassert "+sub.Value+" "+_1d.Value+" "+obj.Value);
this.datasource.Unassert(sub,_1d,obj,true);
},persist:function(obj){
logger.debug("persist "+obj._curi+obj.about);
if(!(obj._curi&&obj.about)){
return;
}
this.datasource.beginUpdateBatch();
var _20=rdfService.GetResource(obj.about);
var _21=rdfService.GetResource(obj._curi);
if(rdfContainerUtils.indexOf(this.datasource,_21,_20)<0){
var _22=rdfContainerUtils.MakeSeq(this.datasource,_21);
_22.AppendElement(_20);
}
var _23,_24;
for(var key in obj){
if(key.charAt(0)=="_"||key=="about"){
continue;
}
_24=obj[key];
if(_24){
var _26=typeof (_24);
_23=rdfService.GetResource(obj["_"+key]);
if(_26=="object"){
if(_24 instanceof Array){
for(var _27 in _24){
this.assert(_20,_23,rdfService.GetResource(_24[_27].about));
}
}else{
this.assert(_20,_23,rdfService.GetResource(_24.about));
}
}else{
_24=rdfService.GetLiteral(_24);
this.assert(_20,_23,_24);
}
}
}
this.assert(_20,this._rdfType,rdfService.GetResource(obj._type));
this.datasource.endUpdateBatch();
},deleteObject:function(obj){
var _29=rdfService.GetResource(obj.about);
this.deleteResource(_29);
},deleteResource:function(_2a){
logger.info("delete "+_2a.Value);
this.datasource.beginUpdateBatch();
try{
var _2b=this.datasource.ArcLabelsIn(_2a);
while(_2b.hasMoreElements()){
var arc=_2b.getNext();
arc=arc.QueryInterface(Ci["nsIRDFResource"]);
var _2d=this.datasource.GetSource(arc,_2a,true);
this.datasource.Unassert(_2d,arc,_2a,true);
}
_2b=this.datasource.ArcLabelsOut(_2a);
while(_2b.hasMoreElements()){
var arc=_2b.getNext();
var _2e=this.datasource.GetTargets(_2a,arc,true);
while(_2e.hasMoreElements()){
var _2f=_2e.getNext();
this.datasource.Unassert(_2a,arc,_2f,true);
}
}
this.datasource.endUpdateBatch();
}
catch(e){
logger.error("delete "+_2a.Value+" error "+e);
}
},flush:function(){
try{
this.datasource.QueryInterface(Ci.nsIRDFRemoteDataSource).Flush();
}
catch(e){
logger.error("flush error "+e);
}
},getItems:function(){
return getList(this.datasource,Item.prototype);
},getTags:function(){
return getList(this.datasource,Tag.prototype);
},getExtractors:function(){
return getList(this.datasource,ExtractorProfile.prototype);
},isTypeOf:function(_30,_31){
return this.datasource.GetTarget(_30,this._rdfType,true)==rdfService.GetResource(_31);
},isTagged:function(_32,_33){
var _34=rdfService.GetResource("urn:foxcart:tag#item");
l:
for(var key in _32){
var _36=_32[key];
var _37=this.datasource.GetTargets(_33,_34,true);
while(_37.hasMoreElements()){
if(_36==_37.getNext()){
continue l;
}
}
return false;
}
return true;
}};
function getList(_38,_39,_3a){
var _3b=new Array;
try{
logger.info("get list for "+_39._curi);
var _3c=rdfService.GetResource(_39._curi);
var _3d=Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
try{
_3d.Init(_38,_3c);
}
catch(e){
if(!_3a){
logger.error("getList error retry");
return getList(_38,_39,true);
}
logger.error("getList error failed");
return [];
}
var _3e=_3d.GetElements();
while(_3e.hasMoreElements()){
var _3f=_3e.getNext();
if(!(_3f instanceof Components.interfaces.nsIRDFResource)){
break;
}
var obj=new Object;
obj.prototype=_39;
for(var key in _39){
if(key.charAt(0)!="_"&&typeof (_39[key])!="object"){
if(key=="about"){
obj[key]=_3f.Value;
}else{
obj[key]=getLiteralValue(_38,_3f,_39["_"+key]);
}
}
}
_3b.push(obj);
}
}
catch(e){
logger.error(e);
}
return _3b;
}
function getLiteralValue(_42,_43,_44){
logger.debug("get "+_43.Value+" property "+_44);
var _45=rdfService.GetResource(_44);
var _46=_42.GetTarget(_43,_45,true);
if(_46){
return _46.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
}
return "";
}
var cartSession=new CartSession();
var HCLASS="foxcart-highlight";
function highlight(_47){
var _48=_47.className;
if(_48==""){
_47.className=HCLASS;
}else{
if(_48.indexOf(HCLASS)<0){
_47.className=_48+" "+HCLASS;
}
}
}
function deHighlight(_49){
var _4a=_49.className;
var n=_4a.indexOf(HCLASS);
if(n>=0){
_4a=_4a.substring(0,n)+_4a.substring(n+HCLASS.length);
_49.className=_4a;
}
}
function instrumentContentDocument(_4c){
var _4d=_4c.getElementById("hstyle");
if(!_4d){
var _4e=_4c.getElementsByTagName("head").item(0);
if(_4e){
_4d=_4c.createElement("style");
}else{
_4e=_4c.getElementsByTagNameNS("http://www.w3.org/1999/xhtml","head").item(0);
_4d=_4c.createElementNS("http://www.w3.org/1999/xhtml","style");
}
_4d.id="hstyle";
_4d.innerHTML=".foxcart-highlight { background-color: #ffff80; border: 1px solid #0000ff; }";
_4e.appendChild(_4d);
}
}
var windowManager=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
function getTabBrowser(){
return windowManager.getMostRecentWindow("navigator:browser").document.getElementById("content");
}
function getCurrentBrowser(){
return getTabBrowser().selectedBrowser;
}
function getCurrentDocument(){
return getCurrentBrowser().contentDocument;
}
function openTab(_4f){
var _50=getTabBrowser().browsers;
for(var i=0;i<_50.length;i++){
if(_50[i].currentURI.spec==_4f){
getTabBrowser().tabContainer.selectedIndex=i;
return;
}
}
getTabBrowser().selectedTab=getTabBrowser().addTab(_4f);
}
function openFoxcart(){
openTab("chrome://foxcart/content/foxcart.xul");
}
function openExtractor(){
if(getCurrentDocument() instanceof HTMLDocument){
window.openDialog("chrome://foxcart/content/extractor.xul","","chrome,width=500,height=500,alwaysRaised,centerscreen");
}
}
function getXPath(_52){
if(_52.id&&_52.ownerDocument.getElementById(_52.id)==_52){
return "id('"+_52.id+"')";
}
var _53=_52.parentNode;
if(!_53){
return "";
}
var _54;
switch(_52.nodeType){
case Node.ELEMENT_NODE:
_54=_52.nodeName;
break;
case Node.ATTRIBUTE_NODE:
_54="@"+_52.nodeName;
break;
v;
case Node.TEXT_NODE:
_54="text()";
break;
case Node.PROCESSING_INSTRUCTION_NODE:
_54="processing-instruction()";
break;
case Node.COMMENT_NODE:
_54="comment()";
break;
case Node.DOCUMENT_NODE:
_54="";
break;
case Node.DOCUMENT_FRAGMENT_NODE:
_54="";
break;
case Node.CDATA_SECTION_NODE:
dump("Trying to get the XPath for a node of type CDATA_SECTION_NODE; this should never happen.\n");
_54="";
break;
case Node.ENTITY_REFERENCE_NODE:
dump("Trying to get the XPath for a node of type ENTITY_REFERENCE_NODE; this should never happen.\n");
_54="";
break;
case Node.ENTITY_NODE:
dump("Trying to get the XPath for a node of type ENTITY_NODE; this should never happen.\n");
_54="";
break;
case Node.DOCUMENT_TYPE_NODE:
dump("Trying to get the XPath for a node of type DOCUMENT_TYPE_NODE; this should never happen.\n");
_54="";
break;
case Node.NOTATION_NODE:
dump("Trying to get the XPath for a node of type NOTATION_NODE; this should never happen.\n");
_54="";
break;
default:
dump("Trying to get the XPath for a node of unknown type ("+_52.nodeType+"); this should never happen.\n");
_54="";
break;
}
var _55=this.getIdentifier(_52);
var _56=this.countTwins(_52,_55);
var _57=this.countTwins(_53.lastChild,_55);
var _58=(_57>1?"["+_56+"]":"");
var _59=this.getXPath(_53)+"/"+_54+_58;
logger.debug(_52+" path:"+_59);
return _59;
}
function countTwins(_5a,_5b){
var _5c=0;
while(_5a){
var _5d=this.getIdentifier(_5a);
if(_5d==_5b){
_5c++;
}
_5a=_5a.previousSibling;
}
return _5c;
}
function getIdentifier(_5e){
if(_5e.localName){
return (_5e.namespaceURI?_5e.namespaceURI+":"+_5e.localName:_5e.localName);
}else{
return _5e.nodeName;
}
}
function getNodeIndex(_5f){
if(_5f.nodeType!=1||_5f.parentNode==null){
return null;
}
var _60=getChildNodesWithTagName(_5f.parentNode,_5f.tagName);
if(_60.length==1&&_60[0]==_5f){
return null;
}
for(var i=0;i<_60.length;i++){
if(_60[i]==_5f){
return i+1;
}
}
throw "couldn't find node in parent's list: "+_5f.tagName;
}
function getTextNodeIndex(_62){
var _63=getChildTextNodes(_62.parentNode);
if(_63.length==1&&_63[0]==_62){
return null;
}
for(var i=0;i<_63.length;i++){
if(_63[i]==_62){
return i+1;
}
}
throw "couldn't find node in parent's list: "+_62.tagName;
}
function getChildNodesWithTagName(_65,_66){
var _67=[];
var _68=_65.firstChild;
while(_68!=null){
if(_68.tagName&&_68.tagName==_66){
_67.push(_68);
}
_68=_68.nextSibling;
}
return _67;
}
function getChildTextNodes(_69){
var _6a=[];
var _6b=_69.firstChild;
while(_6b!=null){
if(_6b.nodeType==3){
_6a.push(_6b);
}
_6b=_6b.nextSibling;
}
return _6a;
}
function getNodePath(_6c){
var _6d=[];
while(_6c.nodeType==1||_6c.nodeType==3){
_6d.unshift(_6c);
if(_6c.nodeType==1&&_6c.hasAttribute("id")){
return _6d;
}
_6c=_6c.parentNode;
}
return _6d;
}
function evalNodeText(_6e,_6f){
logger.debug("evalNodeText path:"+_6e);
try{
var _70=_6f.evaluate(_6e,_6f,null,XPathResult.TYPE_ANY,null);
var _71=_70.iterateNext();
while(_71){
if(_71.textContent){
return _71.textContent;
}
_71=_70.iterateNext();
}
}
catch(e){
logger.error("evaluate "+_6e+" failed. "+e);
}
return "";
}
function evalNodeAttribute(_72,_73,_74){
logger.debug("evalNodeAttribute path:"+_72+",attr:"+_73);
try{
var _75=_74.evaluate(_72,_74,null,XPathResult.TYPE_ANY,null);
var _76=_75.iterateNext();
while(_76){
if(_76.getAttribute(_73)){
return _76.getAttribute(_73);
}
_76=_75.iterateNext();
}
}
catch(e){
logger.error("evaluate "+_72+" failed. "+e);
}
return "";
}
function evalNodeHTML(_77,_78){
try{
var _79=_78.evaluate(_77,_78,null,XPathResult.TYPE_ANY,null);
var _7a=_79.iterateNext();
while(_7a){
if(_7a.parentNode&&_7a.parentNode.innerHTML){
return _7a.parentNode.innerHTML;
}
_7a=_79.iterateNext();
}
}
catch(e){
logger.error("evaluate "+_77+" failed. "+e);
}
return "";
}
function ExtractorDialog(){
}
ExtractorDialog.prototype={extractors:null,profile:null,selectMode:false,windowHeight:0,propertyId:null,selectedNode:null,highlightedNode:null,controllerIds:["topBox","titleBox","priceBox","shipBox","sellerBox","imageBox","descriptionBox","feedbackBox","topSep"],init:function(){
getTabBrowser().tabContainer.addEventListener("TabSelect",tabSeleted,true);
this.populateMenulist();
this.windowHeight=top.outerHeight;
try{
if(window.arguments&&window.arguments[0]){
logger.info("select "+this.getProfileIndex(window.arguments[0]));
$("profileList").selectedIndex=this.getProfileIndex(window.arguments[0]);
this.menulistChanged();
}else{
logger.info("select DefaultProfile ");
this.profile=this.getDefaultProfile();
if(this.profile){
this.populate(this.profile);
$("profileList").selectedIndex=this.getProfileIndex(this.profile.name);
}
}
}
catch(e){
throw "initail dialog error "+e;
}
},disposeDialog:function(){
getTabBrowser().tabContainer.removeEventListener("TabSelect",tabSeleted,true);
getCurrentDocument().removeEventListener("click",mouseListener,true);
getCurrentDocument().removeEventListener("mouseover",mouseListener,true);
},populateMenulist:function(){
logger.debug("populateMenulist");
this.extractors=cartSession.getExtractors();
$("profileList").removeAllItems();
for(var key in this.extractors){
logger.debug("add menuitem "+this.extractors[key].name);
try{
$("profileList").appendItem(this.extractors[key].name,this.extractors[key].name);
}
catch(e){
logger.error(e);
}
}
},getDefaultProfile:function(){
var _7c=getCurrentBrowser().currentURI.host;
var _7d;
for(var key in this.extractors){
if(_7c==this.extractors[key].host){
return this.extractors[key];
}
}
return null;
},getProfile:function(_7f){
for(var key in this.extractors){
if(_7f==this.extractors[key].name){
return this.extractors[key];
}
}
return null;
},getProfileIndex:function(_81){
for(var i=0;i<this.extractors.length;i++){
if(_81==this.extractors[i].name){
return i;
}
}
return 0;
},populate:function(_83){
var doc=getCurrentDocument();
for(var key in _83){
try{
if($(key+"XPath")){
$(key+"XPath").value=_83[key];
}
if($(key)){
if(key=="image"){
$(key).src=evalNodeAttribute(_83[key],"src",doc);
}else{
if(key=="sellerURL"){
$(key).src=evalNodeAttribute(_83[key],"href",doc);
}else{
if(key=="description"){
$(key).value=evalNodeHTML(_83[key],doc);
}else{
$(key).value=evalNodeText(_83[key],doc);
}
}
}
}
}
catch(e){
logger.error(key+" "+e);
}
}
},menulistChanged:function(){
this.profile=this.getProfile($("profileList").value);
if(this.profile){
this.populate(this.profile);
}
},select:function(aId){
logger.info(this.propertyId+" "+aId);
if(this.propertyId==aId){
return;
}
this.propertyId=aId;
this.selectMode=true;
try{
this.doOK=function(){
this.showAll();
top.resizeTo(top.outerWidth,this.windowHeight);
getCurrentDocument().removeEventListener("click",mouseListener,true);
getCurrentDocument().removeEventListener("mouseover",mouseListener,true);
if(this.highlightedNode){
deHighlight(this.highlightedNode);
}
if(this.selectedNode){
deHighlight(this.selectedNode);
}
this.propertyId=null;
this.selectMode=false;
this.doOK=this.saveItem;
return false;
};
this.show(this.propertyId);
top.resizeTo(top.outerWidth,$(this.propertyId+"Box").boxObject.height+90);
getCurrentDocument().addEventListener("click",mouseListener,true);
getCurrentDocument().addEventListener("mouseover",mouseListener,true);
}
catch(e){
logger.error(e);
}
},show:function(aId){
aId=aId+"Box";
for(var i in this.controllerIds){
if(aId!=this.controllerIds[i]){
document.getElementById(this.controllerIds[i]).hidden=true;
}
}
},showAll:function(){
for(var i in this.controllerIds){
document.getElementById(this.controllerIds[i]).hidden=false;
}
},saveProfile:function(){
if($("profileList").value&&$("profileList").value!=""){
try{
var _8a=new ExtractorProfile();
_8a.about="urn:foxcart:extractor#"+$("profileList").value;
_8a.name=$("profileList").value;
_8a.host=getCurrentBrowser().currentURI.host;
for(var key in _8a){
if($(key+"XPath")){
_8a[key]=$(key+"XPath").value;
}
}
cartSession.persist(_8a);
cartSession.flush();
this.populateMenulist();
logger.error("Profile "+_8a.name+"saved");
}
catch(e){
logger.error("saveProfile error "+e);
}
}
},deleteProfile:function(){
try{
var _8c=this.getProfile($("profileList").value);
cartSession.deleteObject(_8c);
cartSession.flush();
this.populateMenulist();
$("profileList").value="";
}
catch(e){
logger.error("deleteProfile error "+e);
}
},doOK:function(){
return this.saveItem();
},saveItem:function(){
var _8d=new Item();
try{
for(var key in _8d){
if($(key)){
_8d[key]=$(key).value;
}
}
if($("image").src&&$("image").src!=""){
_8d.image=$("image").src;
}
_8d.about=getCurrentBrowser().currentURI.spec;
_8d.date=new Date().format();
cartSession.persist(_8d);
cartSession.flush();
}
catch(e){
logger.error("new item error "+e);
}
return true;
},doCancel:function(){
logger.info("close extractor dialog");
return true;
}};
var extractorDialog=new ExtractorDialog();
function tabSeleted(_8f){
var _90=_8f["originalTarget"]["linkedBrowser"].contentDocument;
var _91=_8f["target"]["linkedBrowser"].contentDocument;
_90.removeEventListener("click",mouseListener,true);
_90.removeEventListener("mouseover",mouseListener,true);
if(extractorDialog.selectMode){
_91.addEventListener("click",mouseListener,true);
_91.addEventListener("mouseover",mouseListener,true);
}
if(extractorDialog.profile){
extractorDialog.populate(extractorDialog.profile);
}
}
mouseListener={handleEvent:function(_92){
if(getCurrentDocument()){
instrumentContentDocument(getCurrentDocument());
}
if(_92.type=="click"){
if(extractorDialog.selectedNode){
deHighlight(extractorDialog.selectedNode);
}
_92.stopPropagation();
_92.preventBubble();
_92.preventDefault();
_92.cancelBubble=true;
var _93=_92.target;
extractorDialog.selectedNode=_93;
try{
if(extractorDialog.propertyId=="image"){
var _94=_93.getAttribute("src");
if(!(_94.indexOf("http")==0||_94.indexOf("ftp")==0)){
var url=getCurrentBrowser().currentURI.spec;
_94=url.substring(0,url.lastIndexOf("/"))+"/"+_94;
}
$(extractorDialog.propertyId).src=_94;
}else{
if(extractorDialog.propertyId=="description"){
$(extractorDialog.propertyId).value=_93.parentNode.innerHTML;
}else{
$(extractorDialog.propertyId).value=_93.textContent;
}
}
var _96=getXPath(_92.target);
logger.debug("select node xpath "+_96);
$(extractorDialog.propertyId+"XPath").value=_96;
}
catch(e){
logger.error(e);
}
}else{
if(extractorDialog.highlightedNode&&extractorDialog.highlightedNode!=extractorDialog.selectedNode){
deHighlight(extractorDialog.highlightedNode);
}
extractorDialog.highlightedNode=_92.target;
highlight(extractorDialog.highlightedNode);
}
}};
var Overlay={onLoad:function(){
this.initialized=true;
},openExtractorDialog:function(_97){
if(_97["button"]==0){
openExtractor();
}else{
if(_97["button"]==1){
openFoxcart();
}
}
},addSubmenus:function(_98){
if(_98.target.getAttribute("id")!="fc-profiles-popup"){
return;
}
logger.info("show popup");
try{
var _99=cartSession.getExtractors();
if(_99.length>0){
var _9a=document.getElementById("fc-profiles-popup");
var _9b;
for(var key in _99){
_9b=document.createElement("menuitem");
_9b.setAttribute("label",_99[key].name);
_9a.appendChild(_9b);
}
}
}
catch(e){
logger.error(e);
}
},removeSubmenus:function(_9d){
if(_9d.target.getAttribute("id")!="fc-profiles-popup"){
return;
}
var _9e=document.getElementById("fc-profiles-popup");
while(_9e.hasChildNodes()&&_9e.lastChild.tagName!="menuseparator"){
_9e.removeChild(_9e.lastChild);
}
},hideSubmenus:function(_9f){
logger.info("hide popup");
document.getElementById("fc-profiles-popup").hidePopup();
document.getElementById("fc-popup").hidePopup();
},openExtractorUseProfile:function(_a0){
var _a1=_a0.target.getAttribute("label");
if(getCurrentDocument() instanceof HTMLDocument){
window.openDialog("chrome://foxcart/content/extractor.xul","","chrome,width=500,height=500,alwaysRaised,centerscreen",_a1);
}
}};
window.addEventListener("load",function(e){
Overlay.onLoad(e);
},false);
var cartListController={selection:[],tree:null,selectionChanged:function(_a3){
var _a4=this.selection;
try{
this.selection=[];
this.tree=_a3.target;
var _a5=this.tree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
var _a6=new Object();
var end=new Object();
var _a8=this.tree.view.selection.getRangeCount();
for(var t=0;t<_a8;t++){
this.tree.view.selection.getRangeAt(t,_a6,end);
for(var v=_a6.value;v<=end.value;v++){
this.selection[this.selection.length]=_a5.getResourceAtIndex(v);
}
}
}
catch(e){
this.selection=_a4;
}
if(this.selection.length==1){
var _ab=getLiteralValue(cartSession.datasource,this.selection[0],"urn:foxcart:item#image");
if(_ab){
$("fc-details-image").src=_ab;
}else{
$("fc-details-image").src="chrome://foxcart/skin/image_not_found.jpg";
}
var _ac=document.createTextNode(getLiteralValue(cartSession.datasource,this.selection[0],"http://purl.org/dc/elements/1.1/title"));
var _ad=$("fc-details-title").childNodes;
for(var i=0;i<_ad.length;i++){
$("fc-details-title").removeChild(_ad[i]);
}
$("fc-details-title").appendChild(_ac);
$("fc-details-price").value=getLiteralValue(cartSession.datasource,this.selection[0],"urn:foxcart:item#price");
$("fc-details-ship").value=getLiteralValue(cartSession.datasource,this.selection[0],"urn:foxcart:item#ship");
$("fc-details-seller").value=getLiteralValue(cartSession.datasource,this.selection[0],"urn:foxcart:item#seller");
$("fc-details-feedback").value=getLiteralValue(cartSession.datasource,this.selection[0],"urn:foxcart:item#feedback");
$("fc-details-desc").contentDocument.body.innerHTML=getLiteralValue(cartSession.datasource,this.selection[0],"http://purl.org/dc/elements/1.1/description");
}
},supportsCommand:function(_af){
switch(_af){
case "cmd_delete":
case "cmd_fc_item_new":
case "cmd_fc_item_edit":
case "cmd_fc_item_open":
case "cmd_fc_item_tag":
case "cmd_fc_tag_new":
case "cmd_fc_tag_apply":
case "cmd_fc_list_refresh":
case "cmd_fc_toggletags":
case "cmd_fc_toggledetail":
return true;
break;
default:
return false;
}
return false;
},doCommand:function(_b0){
logger.info("doCommand "+_b0);
switch(_b0){
case "cmd_delete":
var sel=this.selection;
while((element=sel.pop())){
try{
cartSession.deleteResource(element);
}
catch(e){
logger.error(e);
}
}
cartSession.flush();
break;
case "cmd_fc_item_open":
if(this.selection){
for(var key in this.selection){
logger.debug("open "+this.selection[key].Value);
try{
openTab(this.selection[key].Value);
}
catch(e){
logger.debug("open error"+e);
}
}
}
break;
case "cmd_fc_list_refresh":
if(this.tree){
this.tree.builder.rebuild();
}
break;
case "cmd_fc_toggletags":
var _b3=$("fc-toolbar-tagstoogle").checked;
if(_b3){
$("fc-tree").ref="urn:foxcart:items";
$("fc-tree").builder.rebuild();
}else{
$("fc-tree").ref="urn:foxcart:tags";
$("fc-tree").builder.rebuild();
}
$("fc-toolbar-tagstoogle").checked=!_b3;
break;
case "cmd_fc_toggledetail":
var _b4=$("fc-toolbar-detailstoggle").checked;
$("fc-details").collapsed=_b4;
$("fc-splitter").collapsed=_b4;
$("fc-toolbar-detailstoggle").checked=!_b4;
break;
}
},isCommandEnabled:function(_b5){
switch(_b5){
case "cmd_fc_item_new":
case "cmd_fc_hidedetail":
case "cmd_fc_showdetail":
return true;
case "cmd_delete":
return this.selection&&this.selection.length>0;
case "cmd_fc_item_edit":
case "cmd_fc_item_open":
case "cmd_fc_item_tag":
case "cmd_fc_tag_apply":
return this.isType("urn:foxcart:cart#item");
case "cmd_fc_tag_new":
return this.isType("urn:foxcart:cart#tag");
default:
return false;
}
return false;
},onEvent:function(_b6){
logger.info("cartController receive event "+_b6);
},isType:function(_b7){
if(!this.selection){
return false;
}
try{
for(var key in this.selection){
if(!cartSession.isTypeOf(this.selection[key],_b7)){
return false;
}
}
return this.selection.length>0;
}
catch(e){
}
return false;
}};
Date.prototype.format=function(){
return this.getFullYear()+"-"+(this.getMonth()+1)+"-"+this.getDate();
};

